Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.query
Class XQueryFunctionLibrary

    java.lang.Object
      net.sf.saxon.query.XQueryFunctionLibrary

All Implemented Interfaces:
  Serializable, FunctionLibrary, XQueryFunctionBinder

    public class XQueryFunctionLibrary

extends Object
implements FunctionLibrary, XQueryFunctionBinder

An XQueryFunctionLibrary is a function library containing all the user-defined functions available for use within a particular XQuery module: that is, the functions declared in that module, and the functions imported from other modules. It also contains (transiently during compilation) a list of function calls within the module that have not yet been bound to a specific function declaration.

See Also:
  Serialized Form

Constructor Summary
`XQueryFunctionLibrary(Configuration config)` Create an XQueryFunctionLibrary

Method Summary
`Expression` | `bind(StructuredQName functionName, Expression[] arguments, StaticContext env, Container container)` Identify a (namespace-prefixed) function appearing in the expression.
`FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
`void` | `declareFunction(XQueryFunction function)` Register a user-defined XQuery function
`void` | `explainGlobalFunctions(ExpressionPresenter out)` Output "explain" information about each declared function
`protected void` | `fixupGlobalFunctions(QueryModule env)` Fixup all references to global functions.
`Configuration` | `getConfiguration()` Get the Configuration options
`XQueryFunction` | `getDeclaration(StructuredQName functionName, Expression[] staticArgs)` Get the function declaration corresponding to a given function name and arity
`XQueryFunction` | `getDeclarationByKey(String functionKey)` Get the function declaration corresponding to a given function name and arity, supplied in the form "{uri}local/arity"
`Iterator<XQueryFunction>` | `getFunctionDefinitions()` Get an iterator over the Functions defined in this module
`SequenceType[]` | `getFunctionSignature(StructuredQName functionName, int arity)` Test whether a function with a given name and arity is available; if so, return its signature.
`UserFunction` | `getUserDefinedFunction(String uri, String localName, int arity)` Get the function with a given name and arity.
`protected void` | `optimizeGlobalFunctions()` Optimize the body of all global functions.
`void` | `setConfiguration(Configuration config)` Set the Configuration options

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### XQueryFunctionLibrary

    public XQueryFunctionLibrary(Configuration config)

  Create an XQueryFunctionLibrary

  Parameters:
    `config` - the Saxon configuration

Method Detail

### setConfiguration

    public void setConfiguration(Configuration config)

  Set the Configuration options

  Parameters:
    `config` - the Saxon configuration

### getConfiguration

    public Configuration getConfiguration()

  Get the Configuration options

  Returns:
    the Saxon configuration

### declareFunction

    public void declareFunction(XQueryFunction function)
                         throws XPathException

  Register a user-defined XQuery function

  Parameters:
    `function` - the function to be registered
  Throws:
    `XPathException` - if there is an existing function with the same name and arity

### getFunctionSignature

    public SequenceType[] getFunctionSignature(StructuredQName functionName,
                                               int arity)

  Test whether a function with a given name and arity is available; if so, return its signature. This supports the function-available() function in XSLT; it is also used to support higher-order functions introduced in XQuery 1.1.

  This method may be called either at compile time or at run time. If the function library is to be used only in an XQuery or free-standing XPath environment, this method may throw an UnsupportedOperationException.

  Specified by:
    `getFunctionSignature` in interface `FunctionLibrary`
  Parameters:
    `functionName` - the qualified name of the function being called
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument function-available() function; in this case the method should return true if there is some function of this name available for calling.
  Returns:
    if a function of this name and arity is available for calling, then the type signature of the function, as an array of sequence types in which the zeroth entry represents the return type; or a zero-length array if the function exists but the signature is not known; or null if the function does not exist

### bind

    public Expression bind(StructuredQName functionName,
                           Expression[] arguments,
                           StaticContext env,
                           Container container)
                    throws XPathException

  Identify a (namespace-prefixed) function appearing in the expression. This method is called by the XQuery parser to resolve function calls found within the query.

  Note that a function call may appear earlier in the query than the definition of the function to which it is bound. Unlike XSLT, we cannot search forwards to find the function definition. Binding of function calls is therefore a two-stage process; at the time the function call is parsed, we simply register it as pending; subsequently at the end of query parsing all the pending function calls are resolved. Another consequence of this is that we cannot tell at the time a function call is parsed whether it is a call to an internal (XSLT or XQuery) function or to an extension function written in Java.

  Specified by:
    `bind` in interface `FunctionLibrary`
  Parameters:
    `functionName` - the QName of the function being called
    `arguments` - The expressions supplied statically in arguments to the function call. The length of this array represents the arity of the function. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality()) may be used as part of the binding algorithm. In some cases it may be possible for the function to be pre-evaluated at compile time, for example if these expressions are all constant values.

    The conventions of the XPath language demand that the results of a function depend only on the values of the expressions supplied as arguments, and not on the form of those expressions. For example, the result of f(4) is expected to be the same as f(2+2). The actual expression is supplied here to enable the binding mechanism to select the most efficient possible implementation (including compile-time pre-evaluation where appropriate).

    `env` - The static context of the function call
    `container` - The container for the newly created Expression
  Returns:
    an Expression representing the function call. This will normally be a FunctionCall, but it may be rewritten as some other expression.
  Throws:
    `XPathException` - if the function call is invalid, either because it is an unprefixed call to a non-system function, or because it is calling a system function that is available in XSLT only. A prefixed function call that cannot be recognized at this stage is assumed to be a forwards reference, and is bound later when bindUnboundFunctionCalls() is called.

### getDeclaration

    public XQueryFunction getDeclaration(StructuredQName functionName,
                                         Expression[] staticArgs)

  Get the function declaration corresponding to a given function name and arity

  Specified by:
    `getDeclaration` in interface `XQueryFunctionBinder`
  Parameters:
    `functionName` - the name of the function as a QName
    `staticArgs` - the expressions supplied as arguments in the function call (typically, we only need to know the number of arguments)
  Returns:
    the XQueryFunction if there is one, or null if not.

### getDeclarationByKey

    public XQueryFunction getDeclarationByKey(String functionKey)

  Get the function declaration corresponding to a given function name and arity, supplied in the form "{uri}local/arity"

  Parameters:
    `functionKey` - a string in the form "{uri}local/arity" identifying the required function
  Returns:
    the XQueryFunction if there is one, or null if not.

### getFunctionDefinitions

    public Iterator<XQueryFunction> getFunctionDefinitions()

  Get an iterator over the Functions defined in this module

  Returns:
    an Iterator, whose items are `XQueryFunction` objects. It returns all function known to this module including those imported from elsewhere; they can be distinguished by their namespace.

### fixupGlobalFunctions

    protected void fixupGlobalFunctions(QueryModule env)
                                 throws XPathException

  Fixup all references to global functions. This method is called on completion of query parsing. Each XQueryFunction is required to bind all references to that function to the object representing the run-time executable code of the function.

  This method is for internal use.

  Parameters:
    `env` - the static context for the main query body.
  Throws:
    `XPathException`

### optimizeGlobalFunctions

    protected void optimizeGlobalFunctions()
                                    throws XPathException

  Optimize the body of all global functions. This may involve inlining functions calls

  Throws:
    `XPathException`

### explainGlobalFunctions

    public void explainGlobalFunctions(ExpressionPresenter out)

  Output "explain" information about each declared function

  Parameters:
    `out` - the ExpressionPresenter that renders the output

### getUserDefinedFunction

    public UserFunction getUserDefinedFunction(String uri,
                                               String localName,
                                               int arity)

  Get the function with a given name and arity. This method is provided so that XQuery functions can be called directly from a Java application. Note that there is no type checking or conversion of arguments when this is done: the arguments must be provided in exactly the form that the function signature declares them.

  Parameters:
    `uri` - the uri of the function name
    `localName` - the local part of the function name
    `arity` - the number of arguments.
  Returns:
    the function identified by the URI, local name, and arity; or null if there is no such function

### copy

    public FunctionLibrary copy()

  This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.

  Specified by:
    `copy` in interface `FunctionLibrary`
  Returns:
    a copy of this function library. This must be an instance of the original class.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.